#!/usr/bin/env python

import string, whrandom, sys

heroes_male = [
    # inspired by Andariel, Eddings, made up
    ["An-dar-iel", "En-dor-ian", "Al-gor-ain", "Bel-shar-ion", "In-dur-as",
     "El-dan-ien", "Bel-gar-ian", "Al-dar-on", "Bel-gar-ath", "Al-mar-en",
     "An-cal-agon", "En-car-adan", "In-gol-udim", "On-dor-grim",
     "Al-can-grist", "Il-mor-adan", "E-lor-an"],
    # Edain from Tolkien
    ["Fa-ra-mir", "Ba-ra-hir", "Ba-ra-gund", "Ha-la-din", "A-ra-gon"], 
    # More Edain & Tolkien
    ["Hal-dor", "Bel-dane", "Ban-grim", "Mor-thag", "Gon-dor", "Gan-dalf"],
    ["Maedh-ros", "Goth-rim", "Stael-ring", "Glath-rion", "Aeth-rian",
     "Luth-ram" ],
    # Elves
    ["Fin-gol-fin"],
    # Egil's saga
    ["Bryn-jolf", "Hall-bjorn", "Kvel-dulf", "Sal-bjorg", "Bjor-golf",
     "Skalla-grim", "Thor-finn", "Arin-vald", "Thor-dar", "Hall-dor",
     "Thjo-dolf", "Thor-berg", "Arn-stein"],
    # English kings & Beowulf
    ["Hroth-gar", "Healf-dene", "Heoro-gar", "Heoro-weard", "Hroth-mund",
     "Here-beald"],
    ["Aethel-red", "Aethel-stan", "Beo-wulf"],
    # King Harald's Saga & made up
    ["Snorri- the Quiet", "Sigurd- Bear Killer", "Olaf- Eriksson",
     "Ketil- the Strong", "Knut- Fine Hair", "Erik- Bloodaxe",
     "Magnus- the White", "Hakon- the Black", "Leif- the Bold",
     "Bjorn- the Wanderer", "Wulf- the Bald" ],
    # misc
    ["Grim", "Breca", "Hama", "Oslaf", "Wenceslas", "Hengest", "Hygelac"]
    ]

heroes_female = [
    # inspired by Andariel, Eddings, made up
    ["An-dar-iel", "En-dor-ian", "Al-gor-ain", "Bel-shar-ion", "In-dur-as",
     "El-dan-ien", "Bel-gar-ian", "Al-dar-on", "Bel-gar-ath", "Al-mar-en",
     "An-cal-agon", "En-car-adan", "In-gol-udim", "On-dor-grim",
     "Al-can-grist", "Il-mor-adan", "E-lor-an"],
    # Edain from Tolkien
    ["Fa-ra-mir", "Ba-ra-hir", "Ba-ra-gund", "Ha-la-din", "A-ra-gon"], 
    # More Edain & Tolkien
    ["Hal-dor", "Bel-dane", "Ban-grim", "Mor-thag", "Gon-dor", "Gan-dalf"],
    ["Maedh-ros", "Goth-rim", "Stael-ring", "Glath-rion", "Aeth-rian",
     "Luth-ram" ],
    # Elves
    ["Fin-gol-fin"],
    # Egil's saga
    ["Bryn-jolf", "Hall-bjorn", "Kvel-dulf", "Sal-bjorg", "Bjor-golf",
     "Skalla-grim", "Thor-finn", "Arin-vald", "Thor-dar", "Hall-dor",
     "Thjo-dolf", "Thor-berg", "Arn-stein"],
    # English kings & Beowulf
    ["Hroth-gar", "Healf-dene", "Heoro-gar", "Heoro-weard", "Hroth-mund",
     "Here-beald"],
    ["Aethel-red", "Aethel-stan", "Beo-wulf"],
    # King Harald's Saga & made up
    ["Snorri- the Quiet", "Sigurd- Bear Killer", "Olaf- Eriksson",
     "Ketil- the Strong", "Knut- Fine Hair", "Erik- Bloodaxe",
     "Magnus- the White", "Hakon- the Black", "Leif- the Bold",
     "Bjorn- the Wanderer", "Wulf- the Bald" ],
    # misc
    ["Grim", "Breca", "Hama", "Oslaf", "Wenceslas", "Hengest", "Hygelac"]
    ]

def concat(list):
    result = ""
    for l in list:
        result = result + l
    return result

class NameGenerator:
    def __init__(self, className, options):
        self.className = className
        self.options = []
        self.total = 0
        for option in options:
            weight = self.optionSize(option)
            self.total = self.total + weight
            weight = weight / 10
            if weight == 0:
                weight = 1
            for x in range(weight):
                self.options.append(option)
        
    def optionSize(self, option):
        "Number of names which could be generated from this option."
        size = 1
        for list in option:
            size = size * len(list)
        return size

    def generate(self):
        pattern = whrandom.choice(self.options)
	name = ""
	for syls in pattern:
	    name = name + whrandom.choice(syls)
	return name

def compile(className, names):
    options = []
    for pattern in names:
    	lists = []
        numSyllables = -1
        for name in pattern:
            syllables = string.split(name, "-")
            if numSyllables < 0:
                numSyllables = len(syllables)
                lists = []
                for x in range(numSyllables):
                    lists.append([])
            else:
                if len(syllables) != numSyllables:
                    print "%s doesn't fit" % name
                    continue
	    for i in range(len(syllables)):
	        syl = syllables[i]
	        l = lists[i]
	        if syl not in l:
	            l.append(syl)
	if len(lists[0]) > 0:
	    options.append(lists)
    return NameGenerator(className, options)

def print_usage():
    print """\
    Usage: ./hero_names <count> <male/female>
    e.g:   ./hero_name 2 m
    """

if len(sys.argv) < 2:
    print_usage()

if sys.argv[2] == "m":
    compiled = compile("heroes", heroes_male)
elif sys.argv[2] == "f":
    compiled = compile("heroes", heroes_female)
else:
    print_usage()
    
    
#print compiled.total

result = []
count = int(sys.argv[1])

while len(result) < count:
    name = compiled.generate()
    if name not in result:
        result.append(name)

file = open("new_name", "w")
for x in result:
    file.write(x)
    
